(*  GREATIS RUNTIME FUSION                               *)
(*  Copyright (C) 2005-2014 Greatis Software             *)
(*                                                       *)
(*  FORM DESIGNER AND OBJECT INSPECTOR ARE REQUIRED      *)
(*  http://www.greatis.com/delphicb/formdes/             *)
(*  http://www.greatis.com/delphicb/objinsp/             *)
(*                                                       *)
(*  http://www.greatis.com/delphicb/runtime/             *)

unit OIForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CompInsp, InspCtrl, ComCtrls, TypInfo, RunFus, Design, DBCtrls;

type
  TfrmObjectInspector = class(TForm)
    tbcObjectInspector: TTabControl;
    cmpObjectInspector: TRFInspector;
    cmbObjectInspector: TRFComboBox;
    procedure FormResize(Sender: TObject);
    procedure tbcObjectInspectorChange(Sender: TObject);
    procedure cmbObjectInspectorFilter(Sender: TObject;
      AComponent: TComponent; var EnableAdd: Boolean);
    procedure cmbObjectInspectorChange(Sender: TObject);
    procedure cmpObjectInspectorGetValuesList(Sender: TObject;
      TheIndex: Integer; const Strings: TStrings);
    procedure FormShow(Sender: TObject);
    procedure cmpObjectInspectorGetButtonType(Sender: TObject;
      TheIndex: Integer; var Value: TButtonType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmObjectInspector: TfrmObjectInspector;

implementation

{$R *.DFM}

uses FDMain;

procedure TfrmObjectInspector.FormResize(Sender: TObject);
begin
  cmbObjectInspector.Width:=ClientWidth;
  tbcObjectInspector.Height:=ClientHeight-cmbObjectInspector.Height-4;
end;

procedure TfrmObjectInspector.tbcObjectInspectorChange(Sender: TObject);
begin
  with cmpObjectInspector do
  begin
    Lock;
    try
      Mode:=TCompInspMode(tbcObjectInspector.TabIndex);
    finally
      Unlock;
    end;
  end;
end;

procedure TfrmObjectInspector.cmbObjectInspectorFilter(Sender: TObject;
  AComponent: TComponent; var EnableAdd: Boolean);
begin
  EnableAdd:=AComponent is TControl;
end;

procedure TfrmObjectInspector.cmbObjectInspectorChange(Sender: TObject);
begin
  frmDesign.cmpFormDesigner.Control:=TControl(cmbObjectInspector.Instance);
end;

procedure TfrmObjectInspector.cmpObjectInspectorGetValuesList(
  Sender: TObject; TheIndex: Integer; const Strings: TStrings);
var
  i: Integer;
begin
  with Sender as TComponentInspector do
    if Instance is TDBEdit then
      with TDBEdit(Instance).DataSource.DataSet do
        for i:=0 to Pred(Fields.Count) do
  Strings.Add(Fields[i].DisplayName);
end;

procedure TfrmObjectInspector.FormShow(Sender: TObject);
begin
  cmpObjectInspector.DefaultInstance:=frmDesign;
end;

procedure TfrmObjectInspector.cmpObjectInspectorGetButtonType(
  Sender: TObject; TheIndex: Integer; var Value: TButtonType);
begin
  with Sender as TComponentInspector do
    if Properties[TheIndex].Name='DataField' then Value:=btDropDown;
end;

end.
